unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;



type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var abyte, bbyte : byte;  //One byte has 8 bits
    ainteger, binteger : integer;


begin
   //Arithmetic operators
   Memo1.Lines.Add(FloatToStr(5+2.5)); //: +
   Memo1.Lines.Add(FloatToStr(6-2.2)); //: -
   Memo1.Lines.Add(FloatToStr(6*1.5)); //: *
   Memo1.Lines.Add(FloatToStr(6/1.6)); //: /
   Memo1.Lines.Add(IntToStr(6 div 4));
   //div performs integer division, discarding the remainder
   Memo1.Lines.Add(IntToStr(6 mod 4));
   //The mod gives the remainder from the division.

   //parenthesis
   Memo1.Lines.Add( IntToStr(1+1+(-3)) );


   //String operators
   Memo1.Lines.Add('Hello' + 'World');
   Memo1.Lines.Add('Hello' + 'World' + 'Again !');





   //The binary number can be specified by preceding it with a percent sign (%).
   abyte:= %11101000; // % : binary input 11101000 = 232 decimal
   Memo1.Lines.Add('Print abyte like binary: ' + binStr(abyte,8));
   Memo1.Lines.Add('Print abyte like decimal: ' + IntToStr(abyte));


   //Bitwise and
   bbyte:= 0;
   bbyte:=abyte and %00110000; {mask tecnique select onlt 3rd and 4rh element
                                bbyte will become 00100000}
   Memo1.Lines.Add('Print bbyte AND like binary: ' + binStr(bbyte,8));
   Memo1.Lines.Add('Print bbyte AND like decimal: ' + IntToStr(bbyte));


   //Bitwise or
   bbyte:= 0;
   bbyte:=abyte or %00110000; {set 3rd and 4rh element high(1) and leave
                               unaltered the rest.
                               bbyte will become 11111000}
   Memo1.Lines.Add('Print bbyte OR like binary: ' + binStr(bbyte,8));
   Memo1.Lines.Add('Print bbyte OR like decimal: ' + IntToStr(bbyte));

   //Bitwise not
   bbyte:= 0;
   bbyte:=not abyte; {0->1 and 1->0}
   Memo1.Lines.Add('Print bbyte NOT like binary: ' + binStr(bbyte,8));
   Memo1.Lines.Add('Print bbyte NOT like decimal: ' + IntToStr(bbyte));


   //Bitwise shl //abyte:= %11101000;
   bbyte:= 0;
   bbyte:= abyte shl 3; {shift left three positions}
   Memo1.Lines.Add('Print bbyte SHL like binary: ' + binStr(bbyte,8));
   Memo1.Lines.Add('Print bbyte SHL like decimal: ' + IntToStr(bbyte));

   //x shl y = x * 2^y is valid : no overflow
   abyte:= 10;
   bbyte:=0;
   bbyte:= abyte shl 3;
   Memo1.Lines.Add('Print bbyte SHL like binary: ' + binStr(abyte,8));
   Memo1.Lines.Add('Print bbyte SHL like decimal: ' + IntToStr(bbyte));

   //x shl y = x * 2^y is not valid : overflow
   abyte:= 100;
   bbyte:=0;
   bbyte:= abyte shl 3;
   Memo1.Lines.Add('Print bbyte SHL overflow like binary: ' + binStr(abyte,8));
   Memo1.Lines.Add('Print bbyte SHR overfflow like decimal: ' + IntToStr(bbyte));

   //x shl y = x * 2^y is valid : no overflow
   ainteger:= 100;
   binteger:=0;
   binteger:= ainteger shl 3;
   Memo1.Lines.Add('Print binteger SHL like binary: ' + binStr(ainteger,16));
   Memo1.Lines.Add('Print binteger SHL like decimal: ' + IntToStr(binteger));

   //Bitwise shr ;
   abyte:= %11101000;
   bbyte:= 0;
   bbyte:= abyte shr 3; {shift right three positions}
   Memo1.Lines.Add('Print bbyte SHR like binary: ' + binStr(bbyte,8));
   Memo1.Lines.Add('Print bbyte SHR like decimal: ' + IntToStr(bbyte));






end;



end.

